Hot News aus dem CAD.de-Newsletter:

Mit Unterstützung durch:

  Foren auf CAD.de (alle Foren)
  Lisp
  VLA-Objects in Pickset umwandeln

Antwort erstellen  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen nächster neuer Beitrag | nächster älterer Beitrag
Autor Thema:   VLA-Objects in Pickset umwandeln (602 mal gelesen)
Wolfgang S
Mitglied
CADaver


Sehen Sie sich das Profil von Wolfgang S an!   Senden Sie eine Private Message an Wolfgang S  Schreiben Sie einen Gästebucheintrag für Wolfgang S

Beiträge: 270
Registriert: 06.03.2006

AC 2009, C3D 2009, AC 2010, C3D 2010, AC 2011, C3D 2011, RVT 2010, RVT 2011, ASD 2011 und alles darunter bis R14 +
Win XP, Win XP64, Win 7/64

erstellt am: 29. Jun. 2007 08:45    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo alle miteinander!

Ich habe eine Frage:
Kann man ermitteln, ob ein VLA-Object ein "wählbares" Objekt ist? bzw. in welchem Layout dieses Objekt liegt.

möchte eine Liste aus a: enames , b: vla-objects in einen Auswahlsatz umwandeln und habe da ein wenig Bedenken, die "aktuellen Layer", das "aktuelle Layout" usw. in ein Pickset zu bekommen.

Das Proggi selbst verwendet diese Dinge nicht, aber sicher ist sicher. soll ja stabil laufen...
Ist es eventuell sinnvoll, den GC410 auszuwerten, bevor die Elemente übergeben werden?
habe gerade in der ssget-Hilfe gefunden:
but when the selection set is used in an operation, ssget filters out objects from the space not currently in effect.

Code:

(defun sw~list->pickset (LISTE / ITEMENT SELSET)
  (if
    (and
      (= (type LISTE) 'LIST) ;Bedingung 1: Eingabe ist Liste
      (vl-remove-if
  (function (lambda (item)
      (if (OR (= item 'ENAME)
      (= item 'VLA-OBJECT)
      )
T
NIL
)))
    (mapcar 'TYPE LISTE)
  ) ;Bedingung 2: nur enames oder VLA-Objects in der Liste
  )
  (prompt "\nFalsche Eingabeliste!")
  (progn
      (setq selset (ssadd))
      (mapcar
(function (lambda (ITEM)
    (setq ITEMENT
   (cond
     ((= (TYPE ITEM) 'ENAME) ITEM)
     ((= (TYPE ITEM) 'VLA-OBJECT)
      (vlax-vla-object->ename ITEM)
     )
   )
    )
    (ssadd ITEMENT SELSET)
  )
)
LISTE
      )
    )
  )
SELSET
)

LG
Wolfgang S

[Diese Nachricht wurde von Wolfgang S am 29. Jun. 2007 editiert.]

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

CADmium
Moderator
Maschinenbaukonstrukteur




Sehen Sie sich das Profil von CADmium an!   Senden Sie eine Private Message an CADmium  Schreiben Sie einen Gästebucheintrag für CADmium

Beiträge: 13244
Registriert: 30.11.2003

.

erstellt am: 29. Jun. 2007 09:00    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Wolfgang S 10 Unities + Antwort hilfreich

werte doch die Eigenschaft OWNERID des vla-Objektes aus ... da kannst du dann (über ein paar Zwischeschritte wie ObjectIDToObject ..) sehen, ob es zu einem Layoutblock gehört

------------------
  - Thomas -
"Bei 99% aller Probleme ist die umfassende Beschreibung des Problems bereits mehr als die Hälfte der Lösung desselben."

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Wolfgang S
Mitglied
CADaver


Sehen Sie sich das Profil von Wolfgang S an!   Senden Sie eine Private Message an Wolfgang S  Schreiben Sie einen Gästebucheintrag für Wolfgang S

Beiträge: 270
Registriert: 06.03.2006

AC 2009, C3D 2009, AC 2010, C3D 2010, AC 2011, C3D 2011, RVT 2010, RVT 2011, ASD 2011 und alles darunter bis R14 +
Win XP, Win XP64, Win 7/64

erstellt am: 29. Jun. 2007 10:25    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Code:
(defun sw~Object-of-CTAB (vla / OWNERBLOCK OWNERISLAYOUT)
  (setq OwnerisLayout
(vlax-property-available-p
  (setq ownerblock
  (vla-ObjectIDtoObject
    (vla-get-activedocument (vlax-get-acad-object))
    (vla-get-OwnerID vla)
  )
  )
  'Islayout
) ; Element in einem Layout
  )

  (IF (AND OWNERISLAYOUT
  (EQ
    (vla-get-ObjectID
      (vla-get-Block
(vla-get-activeLayout
  (vla-get-activedocument (vlax-get-acad-object))
)
      )
    ) ; ObjectID vom ActiveLayout
    (vla-get-ObjectID ownerblock) ; ObjectID vom Besitzerblock
  )
      )
    T
    NIL
  )
)


sowas da hab ich jetzt gebastelt. funktioniert ganz gut.

gibt für
(sw~Object-of-CTAB (vla-get-activeLayer (vla-get-activedocument (vlax-get-acad-object))))
NIL retour
und für ein Entity T

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag
Antwort erstellen


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag schliessen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2017 CAD.de